#!/usr/bin/python3
import sys
import os
import configparser,logging,os,sys
import psycopg2
import string
import threading,json

logging.basicConfig(
    filename='/home/epm/pylog/syncfrpc.log',  # Specify the log file
    filemode='w',  # Append the log messages to the file
    format='%(asctime)s - %(name)s - %(levelname)s - %(message)s',
    level=logging.DEBUG  # Set the logging level to DEBUG
)
sysapp = logging.getLogger('syncfrpc')

FRPC_TABLE = "app_frpc"
# Connect to the PostgreSQL database
connection = psycopg2.connect(
    user="postgres",
    password="Wang_2023",
    host="hanatest1.epmtest.cn",
    port=5432,
    database="cmdb"
)
connection.autocommit = False
cursor = connection.cursor()

#non common section
def syncCmdb(hostname,hostconfig):
    sysapp.debug(f'in thread {hostname} {hostconfig}')        
       
    for section,v in hostconfig.items():
        try:
            sysapp.info(f"Processing section: {section} {v}")
            if section == "common":
                sysapp.info(f"common section, skip")
                continue
            sql = f"insert into {FRPC_TABLE}(name,server_name,local_ip,local_port,remote_port) values('{section}','{hostname}','{v['local_ip']}','{v['local_port']}','{v['remote_port']}') on conflict (name,server_name) do update set(local_ip,local_port,remote_port) = ('{v['local_ip']}','{v['local_port']}','{v['remote_port']}')"
            sysapp.info(f"sql={sql}")
            cursor.execute(sql)
        except Exception as e:
            sysapp.error(f"Error processing section {section}: {e}")
    connection.commit()
  



def main():
    module = AnsibleModule(
        argument_spec = dict(
            # <--Begin Parameter Definition -->
            hostvars1=dict(required=False, type='dict',default=None),
            # frpc_config=dict(required=False, type='obj',default=None),
            #serverName=dict(required=False, type='str', default='leondev'),
            # <--END Parameter Definition -->
        )
    )
    try:        
        sysapp.info('start sync frpc')
        hostVar=module.params['hostvars1']
        #sysapp.info(f"hostvars1={hostvars1}")
        sysapp.debug(f"hostvars1={hostVar}")
        # hostvalueJs = json.dumps(hostVar)
        # sysapp.debug(f"hostvalueJs: {hostvalueJs}")

        threadAry = []
        for hostname,hostvalue in hostVar.items():
            #hostvalue = hostVar[hostname]
            sysapp.debug(f"Key: {hostname}, hostvalue: {hostvalue}")
            #hostvalue.frpcConfig
            try:
                if 'frpc_config' in hostvalue:
                    frpcCfg = hostvalue['frpc_config']
                    sysapp.debug(f"frpcCfg: {frpcCfg}")
                    # hostvalueJs = json.dumps(hostvalue)
                    # sysapp.debug(f"hostvalueJs: {hostvalueJs}")
                    #frpcCfg = hostvalue.frpc_config
                    threadi = threading.Thread(target=syncCmdb,args=(hostname,frpcCfg,))
                    threadi.start()
                    threadAry.append(threadi)
            except Exception as e:
                sysapp.error(f"Error processing host {hostname}: {e}")
        sysapp.info('all threads start')

        for thread in threadAry:
            thread.join()
        
        message = "frpc sync  done for all hosts"
        sysapp.info(message)   

        module.exit_json(msg=message,data=message)

    except Exception as ex:
        message = "Exception {}: {}".format(type(ex).__name__, str(ex))
        sysapp.info(message)
        # Fail Exit
        module.fail_json(msg="Error Message - %s" % str(ex))
    finally:
    # Close the cursor and connection
        if connection:
            cursor.close()
            connection.close()
            sysapp.info("PostgreSQL connection is closed")

from ansible.module_utils.basic import AnsibleModule
if __name__ == '__main__':
    main()